Index: LMDZ6/trunk/libf/misc/readTracFiles_mod.f90
===================================================================
--- LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 5184)
+++ LMDZ6/trunk/libf/misc/readTracFiles_mod.f90	(revision 5190)
@@ -1893,49 +1910,55 @@
 !==============================================================================================================================
 !==============================================================================================================================
-LOGICAL FUNCTION getKeyByIndex_s1mm(keyn, val, ky, def, lDisp) RESULT(lerr)
-  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn
-  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: val(:)
-  TYPE(keys_type),       OPTIONAL,    INTENT(IN)  ::  ky(:)
-  CHARACTER(LEN=*),      OPTIONAL,    INTENT(IN)  :: def
-  LOGICAL,               OPTIONAL,    INTENT(IN)  :: lDisp
-  lerr = getKeyByIndex_smmm([keyn], val, ky, def, lDisp)
+LOGICAL FUNCTION getKeyByIndex_s1mm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  CHARACTER(LEN=maxlen),           ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::  ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: nam(:)
+  CHARACTER(LEN=*),      OPTIONAL,              INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_smmm([keyn], val, ky, nam, def, lDisp)
 END FUNCTION getKeyByIndex_s1mm
 !==============================================================================================================================
-LOGICAL FUNCTION getKeyByIndex_i1mm(keyn, val, ky, def, lDisp) RESULT(lerr)
-  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn
-  INTEGER,               ALLOCATABLE, INTENT(OUT) :: val(:)
-  TYPE(keys_type),       OPTIONAL,    INTENT(IN)  ::  ky(:)
-  INTEGER,               OPTIONAL,    INTENT(IN)  :: def
-  LOGICAL,               OPTIONAL,    INTENT(IN)  :: lDisp
-  lerr = getKeyByIndex_immm([keyn], val, ky, def, lDisp)
+LOGICAL FUNCTION getKeyByIndex_i1mm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  INTEGER,                         ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::  ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: nam(:)
+  INTEGER,               OPTIONAL,              INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_immm([keyn], val, ky, nam, def, lDisp)
 END FUNCTION getKeyByIndex_i1mm
 !==============================================================================================================================
-LOGICAL FUNCTION getKeyByIndex_r1mm(keyn, val, ky, def, lDisp) RESULT(lerr)
-  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn
-  REAL,                  ALLOCATABLE, INTENT(OUT) :: val(:)
-  TYPE(keys_type),       OPTIONAL,    INTENT(IN)  ::  ky(:)
-  REAL,                  OPTIONAL,    INTENT(IN)  :: def
-  LOGICAL,               OPTIONAL,    INTENT(IN)  :: lDisp
-  lerr = getKeyByIndex_rmmm([keyn], val, ky, def, lDisp)
+LOGICAL FUNCTION getKeyByIndex_r1mm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  REAL,                            ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::  ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: nam(:)
+  REAL,                  OPTIONAL,              INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_rmmm([keyn], val, ky, nam, def, lDisp)
 END FUNCTION getKeyByIndex_r1mm
 !==============================================================================================================================
-LOGICAL FUNCTION getKeyByIndex_l1mm(keyn, val, ky, def, lDisp) RESULT(lerr)
-  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn
-  LOGICAL,               ALLOCATABLE, INTENT(OUT) :: val(:)
-  TYPE(keys_type),       OPTIONAL,    INTENT(IN)  ::  ky(:)
-  LOGICAL,               OPTIONAL,    INTENT(IN)  :: def
-  LOGICAL,               OPTIONAL,    INTENT(IN)  :: lDisp
-  lerr = getKeyByIndex_lmmm([keyn], val, ky, def, lDisp)
+LOGICAL FUNCTION getKeyByIndex_l1mm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn
+  LOGICAL,                         ALLOCATABLE, INTENT(OUT) :: val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::  ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: nam(:)
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
+  lerr = getKeyByIndex_lmmm([keyn], val, ky, nam, def, lDisp)
 END FUNCTION getKeyByIndex_l1mm
 !==============================================================================================================================
 !==============================================================================================================================
-LOGICAL FUNCTION getKeyByIndex_smmm(keyn, val, ky, def, lDisp) RESULT(lerr)
-  CHARACTER(LEN=*),                   INTENT(IN)  :: keyn(:)
-  CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) ::  val(:)
-  TYPE(keys_type),       OPTIONAL,    INTENT(IN)  ::   ky(:)
-  CHARACTER(LEN=*),      OPTIONAL,    INTENT(IN)  ::  def
-  LOGICAL,               OPTIONAL,    INTENT(IN)  :: lDisp
+LOGICAL FUNCTION getKeyByIndex_smmm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn(:)
+  CHARACTER(LEN=maxlen),           ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  nam(:)
+  CHARACTER(LEN=*),      OPTIONAL,              INTENT(IN)  ::  def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen) :: s
+  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname(:)
   INTEGER :: iq, nq(3), k
   LOGICAL :: lD, l(3)
@@ -1944,8 +1967,8 @@
   lerr = .TRUE.
   IF(PRESENT(ky)) THEN;                 val = fgetKey(ky)                                !--- "ky"
-  ELSE IF(ALLOCATED(tracers)) THEN;     val = fgetKey(tracers(:))                        !--- "tracers"
+  ELSE IF(ALLOCATED(tracers)) THEN;     val = fgetKey(tracers(:)%keys)                   !--- "tracers"
      IF(lerr .AND. ASSOCIATED(isotope)) val = fgetKey(isotope%keys(:))                   !--- "isotope"
   END IF
-  IF(.NOT.lerr) RETURN
+  IF(.NOT.lerr) THEN; IF(PRESENT(nam)) nam = tname; RETURN; END IF
   IF(.NOT.PRESENT(def)) THEN; CALL msg('No '//TRIM(s)//' found', modname, lD); RETURN; END IF
 
@@ -1968,4 +1991,5 @@
   INTEGER :: iq
   lerr = SIZE(ky) == 0; IF(lerr) RETURN
+  tname = ky%name
   val = [(fgetKeyIdx(iq, keyn(:), ky, ler(iq)), iq = 1, SIZE(ky))]
   lerr = ANY(ler)
@@ -1974,52 +1998,54 @@
 END FUNCTION getKeyByIndex_smmm
 !==============================================================================================================================
-LOGICAL FUNCTION getKeyByIndex_immm(keyn, val, ky, def, lDisp) RESULT(lerr)
-  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
-  INTEGER,      ALLOCATABLE, INTENT(OUT) ::  val(:)
-  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::   ky(:)
-  INTEGER,         OPTIONAL, INTENT(IN)  ::  def
-  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+LOGICAL FUNCTION getKeyByIndex_immm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn(:)
+  INTEGER,                         ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  nam(:)
+  INTEGER,               OPTIONAL,              INTENT(IN)  ::  def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen) :: s
   CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:), tname(:)
   LOGICAL,               ALLOCATABLE ::    ll(:)
-  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, int2str(def), lDisp)
-  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, lDisp=lDisp)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, int2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, lDisp=lDisp)
   IF(lerr) RETURN
   val = str2int(svals)
-  ll = val == -HUGE(1) .AND. (SIZE(svals) /=1 .OR. svals(1) /= '')
-  lerr = ANY(ll); IF(.NOT.lerr) RETURN
-  IF(getKeyByIndex_smmm(['name'], tname, ky)) RETURN
+  ll = val == -HUGE(1)
+  lerr = ANY(ll); IF(.NOT.lerr) THEN; IF(PRESENT(nam)) nam = tname; RETURN; END IF
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(PACK(tname, MASK=ll)))//' is not'
   CALL msg(TRIM(s)//' an integer: '//TRIM(strStack(svals, MASK=ll)), modname, lerr)
+  IF(.NOT.lerr .AND. PRESENT(nam)) nam = tname
 END FUNCTION getKeyByIndex_immm
 !==============================================================================================================================
-LOGICAL FUNCTION getKeyByIndex_rmmm(keyn, val, ky, def, lDisp) RESULT(lerr)
-  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
-  REAL,         ALLOCATABLE, INTENT(OUT) ::  val(:)
-  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::   ky(:)
-  REAL,            OPTIONAL, INTENT(IN)  ::  def
-  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+LOGICAL FUNCTION getKeyByIndex_rmmm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn(:)
+  REAL,                            ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  nam(:)
+  REAL,                  OPTIONAL,              INTENT(IN)  ::  def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen) :: s
   CHARACTER(LEN=maxlen), ALLOCATABLE :: svals(:), tname(:)
   LOGICAL,               ALLOCATABLE ::    ll(:)
-  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, real2str(def), lDisp)
-  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, lDisp=lDisp)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, real2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, lDisp=lDisp)
   IF(lerr) RETURN
   val = str2real(svals)
-  ll = val == -HUGE(1.) .AND. (SIZE(svals) /=1 .OR. svals(1) /= '')
-  lerr = ANY(ll); IF(.NOT.lerr) RETURN
-  IF(getKeyByIndex_smmm(['name'], tname, ky)) RETURN
+  ll = val == -HUGE(1.)
+  lerr = ANY(ll); IF(.NOT.lerr) THEN; IF(PRESENT(nam)) nam = tname; RETURN; END IF
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(PACK(tname, MASK=ll)))//' is not a'
   CALL msg(TRIM(s)//' a real: '//TRIM(strStack(svals, MASK=ll)), modname)
 END FUNCTION getKeyByIndex_rmmm
 !==============================================================================================================================
-LOGICAL FUNCTION getKeyByIndex_lmmm(keyn, val, ky, def, lDisp) RESULT(lerr)
-  CHARACTER(LEN=*),          INTENT(IN)  :: keyn(:)
-  LOGICAL,      ALLOCATABLE, INTENT(OUT) ::  val(:)
-  TYPE(keys_type), OPTIONAL, INTENT(IN)  ::   ky(:)
-  LOGICAL,         OPTIONAL, INTENT(IN)  ::  def
-  LOGICAL,         OPTIONAL, INTENT(IN)  :: lDisp
+LOGICAL FUNCTION getKeyByIndex_lmmm(keyn, val, ky, nam, def, lDisp) RESULT(lerr)
+  CHARACTER(LEN=*),                             INTENT(IN)  :: keyn(:)
+  LOGICAL,                         ALLOCATABLE, INTENT(OUT) ::  val(:)
+  TYPE(keys_type),       OPTIONAL,              INTENT(IN)  ::   ky(:)
+  CHARACTER(LEN=maxlen), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  nam(:)
+  LOGICAL,               OPTIONAL,              INTENT(IN)  ::  def
+  LOGICAL,               OPTIONAL,              INTENT(IN)  :: lDisp
 !------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen) :: s
@@ -2027,14 +2053,12 @@
   LOGICAL,               ALLOCATABLE ::    ll(:)
   INTEGER,               ALLOCATABLE :: ivals(:)
-  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, bool2str(def), lDisp)
-  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, lDisp=lDisp)
+  IF(     PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, bool2str(def), lDisp)
+  IF(.NOT.PRESENT(def)) lerr = getKeyByIndex_smmm(keyn, svals, ky, tname, lDisp=lDisp)
   IF(lerr) RETURN
   ivals = str2bool(svals)
-  ll = ivals == -1 .AND. (SIZE(svals) /=1 .OR. svals(1) /= '')
-  lerr = ANY(ll); IF(.NOT.lerr) RETURN
-  IF(getKeyByIndex_smmm(['name'], tname, ky)) RETURN
+  ll = ivals == -1
+  lerr = ANY(ll); IF(.NOT.lerr) THEN; val = ivals == 1; IF(PRESENT(nam)) nam = tname; RETURN; END IF
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(tname, MASK=ll))//' is not'
   CALL msg(TRIM(s)//' a boolean: '//TRIM(strStack(svals, MASK=ll)), modname)
-  IF(.NOT.lerr) val = ivals == 1
 END FUNCTION getKeyByIndex_lmmm
 !==============================================================================================================================
@@ -2047,5 +2071,5 @@
 !=== TRY TO GET THE KEY NAMED "key" FOR THE TRACER NAMED "tname" IN:                                                        ===
 !===  * ARGUMENT "ky" DATABASE IF SPECIFIED ; OTHERWISE:                                                                    ===
-!===  * IN INTERNAL TRACERS DATABASE "tracers(:)" (IF UNFOUND, IN INTERNAL ISOTOPES DATABASE "isotope%keys(:)")             ===
+!===  * IN INTERNAL TRACERS DATABASE "tracers(:)%keys" (IF UNFOUND, IN INTERNAL ISOTOPES DATABASE "isotope%keys(:)")        ===
 !=== THE RETURNED VALUE (STRING, AN INTEGER, A REAL OR A LOGICAL) CAN BE EITHER:                                            ===
 !===  * A SCALAR                                                                                                            ===
@@ -2109,5 +2133,5 @@
   tnam = strHead(delPhase(tname),'_',.TRUE.)                                             !--- Remove phase and tag
   IF(lerr .AND. PRESENT(ky))         val = fgetKey(ky)                                   !--- "ky"
-  IF(lerr .AND. ALLOCATED (tracers)) val = fgetKey(tracers(:))                           !--- "tracers"
+  IF(lerr .AND. ALLOCATED (tracers)) val = fgetKey(tracers(:)%keys)                      !--- "tracers"
   IF(lerr .AND. ASSOCIATED(isotope)) val = fgetKey(isotope%keys(:))                      !--- "isotope"
   IF(lerr .AND. PRESENT(def)) THEN
@@ -2121,9 +2145,9 @@
  CHARACTER(LEN=maxlen) FUNCTION fgetKey(ky) RESULT(val)
   TYPE(keys_type),  INTENT(IN)  :: ky(:)
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname_all(:)
-  lerr = SIZE(ky) == 0;                 IF(lerr) RETURN
-  lerr = getKey('name', tname_all, ky); IF(lerr) RETURN
-           val = fgetKeyIdx(strIdx(tname_all, tname), [keyn], ky, lerr)
-  IF(lerr) val = fgetKeyIdx(strIdx(tname_all, tnam ), [keyn], ky, lerr)
+  lerr = SIZE(ky) == 0
+  IF(lerr) RETURN
+           val = fgetKeyIdx(strIdx(ky%name, tname), [keyn], ky, lerr)
+  IF(lerr) val = fgetKeyIdx(strIdx(ky%name, tnam ), [keyn], ky, lerr)
+
 END FUNCTION fgetKey
 
@@ -2142,5 +2166,5 @@
   IF(lerr) RETURN
   val = str2int(sval)
-  lerr = val == -HUGE(1) .AND. sval /= ''
+  lerr = val == -HUGE(1)
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
@@ -2159,5 +2183,5 @@
   IF(lerr) RETURN
   val = str2real(sval)
-  lerr = val == -HUGE(1.) .AND. sval /= ''
+  lerr = val == -HUGE(1.)
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
@@ -2177,5 +2201,5 @@
   IF(lerr) RETURN
   ival = str2bool(sval)
-  lerr = ival == -1 .AND. sval /= ''
+  lerr = ival == -1
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
@@ -2212,5 +2236,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   val = str2int(svals)
-  lerr = ANY(val == -HUGE(1)) .AND. sval /= ''
+  lerr = ANY(val == -HUGE(1))
   s = 'key "'//TRIM(keyn)//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
@@ -2232,5 +2256,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   val = str2real(svals)
-  lerr = ANY(val == -HUGE(1.)) .AND. sval /= ''
+  lerr = ANY(val == -HUGE(1.))
   s = 'key "'//TRIM(keyn)//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
@@ -2253,5 +2277,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   ivals = str2bool(svals)
-  lerr = ANY(ivals == -1) .AND. sval /= ''
+  lerr = ANY(ivals == -1)
   s = 'key "'//TRIM(keyn)//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
@@ -2288,5 +2312,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   val = str2int(svals)
-  lerr = ANY(val == -HUGE(1)) .AND. sval /= ''
+  lerr = ANY(val == -HUGE(1))
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' an integer: '//TRIM(sval), modname, lerr)
@@ -2308,5 +2332,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   val = str2real(svals)
-  lerr = ANY(val == -HUGE(1.)) .AND. sval /= ''
+  lerr = ANY(val == -HUGE(1.))
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' a real: '//TRIM(sval), modname, lerr)
@@ -2329,5 +2353,5 @@
   IF(fmsg('can''t parse '//TRIM(sval), modname, lerr)) RETURN
   ivals = str2bool(svals)
-  lerr = ANY(ivals == -1) .AND. sval /= ''
+  lerr = ANY(ivals == -1)
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(tname)//' is not'
   CALL msg(TRIM(s)//' a boolean: '//TRIM(sval), modname, lerr)
@@ -2388,5 +2412,5 @@
   lerr = .TRUE.
   IF(PRESENT(ky)) THEN;                 val = fgetKey(ky)                                !--- "ky"
-  ELSE IF(ALLOCATED(tracers)) THEN;     val = fgetKey(tracers(:))                        !--- "tracers"
+  ELSE IF(ALLOCATED(tracers)) THEN;     val = fgetKey(tracers(:)%keys)                   !--- "tracers"
      IF(lerr .AND. ASSOCIATED(isotope)) val = fgetKey(isotope%keys(:))                   !--- "isotope"
   END IF
@@ -2403,9 +2427,7 @@
   TYPE(keys_type),       INTENT(IN)  :: ky(:)
   LOGICAL,               ALLOCATABLE :: ler(:)
-  CHARACTER(LEN=maxlen), ALLOCATABLE :: tname_all(:)
-  lerr = SIZE(ky) == 0;                 IF(lerr) RETURN
-  lerr = getKey('name', tname_all, ky); IF(lerr) RETURN
+  lerr = SIZE(ky) == 0; IF(lerr) RETURN
   ALLOCATE(ler(SIZE(tname)))
-  val = [(fgetKeyIdx(strIdx(tname_all, tname(iq)), keyn, ky, ler(iq)), iq = 1, SIZE(tname))]
+  val = [(fgetKeyIdx(strIdx(ky(:)%name, tname(iq)), keyn, ky, ler(iq)), iq = 1, SIZE(tname))]
   lerr = ANY(ler)
 END FUNCTION fgetKey
@@ -2427,5 +2449,5 @@
   IF(lerr) RETURN
   val = str2int(svals)
-  ll = val == -HUGE(1) .AND. (SIZE(svals) /=1 .OR. svals(1) /= '')
+  ll = val == -HUGE(1)
   lerr = ANY(ll); IF(.NOT.lerr) RETURN
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(tname, MASK=ll))//' is not'
@@ -2447,5 +2469,5 @@
   IF(lerr) RETURN
   val = str2real(svals)
-  ll = val == -HUGE(1.) .AND. (SIZE(svals) /=1 .OR. svals(1) /= '')
+  ll = val == -HUGE(1.)
   lerr = ANY(ll); IF(.NOT.lerr) RETURN
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(tname, MASK=ll))//' is not'
@@ -2468,5 +2490,5 @@
   IF(lerr) RETURN
   ivals = str2bool(svals)
-  ll = ivals == -1 .AND. (SIZE(svals) /=1 .OR. svals(1) /= '')
+  ll = ivals == -1
   lerr = ANY(ll); IF(.NOT.lerr) THEN; val = ivals == 1; RETURN; END IF
   s = 'key "'//TRIM(strStack(keyn, '/'))//'" of '//TRIM(strStack(tname, MASK=ll))//' is not'
@@ -2480,5 +2502,5 @@
 !==============================================================================================================================
 SUBROUTINE setKeysDBase(tracers_, isotopes_, isotope_)
-  TYPE(keys_type), OPTIONAL, INTENT(IN) ::  tracers_(:)
+  TYPE(trac_type), OPTIONAL, INTENT(IN) ::  tracers_(:)
   TYPE(isot_type), OPTIONAL, INTENT(IN) :: isotopes_(:)
   TYPE(isot_type), OPTIONAL, INTENT(IN) :: isotope_
@@ -2489,5 +2511,5 @@
   IF(PRESENT(isotopes_)) THEN; isotopes = isotopes_; ELSE; ALLOCATE(isotopes(0)); END IF
   IF(PRESENT(isotope_ )) THEN
-    ix = strIdx(isotopes(:)%name, isotope_%name)
+    ix = strIdx(isotopes(:)%parent, isotope_%parent)
     IF(ix /= 0) THEN
       isotopes(ix) = isotope_
@@ -2500,5 +2522,5 @@
 !==============================================================================================================================
 SUBROUTINE getKeysDBase(tracers_, isotopes_, isotope_)
-  TYPE(keys_type), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  tracers_(:)
+  TYPE(trac_type), OPTIONAL, ALLOCATABLE, INTENT(OUT) ::  tracers_(:)
   TYPE(isot_type), OPTIONAL, ALLOCATABLE, INTENT(OUT) :: isotopes_(:)
   TYPE(isot_type), OPTIONAL,              INTENT(OUT) :: isotope_
@@ -2507,5 +2529,5 @@
   IF(PRESENT( tracers_)) THEN;  tracers_ =  tracers; ELSE; ALLOCATE( tracers_(0)); END IF
   IF(PRESENT(isotopes_)) THEN; isotopes_ = isotopes; ELSE; ALLOCATE(isotopes_(0)); END IF
-  IF(PRESENT(isotope_ )) THEN; ix = strIdx(isotopes(:)%name, isotope%name); IF(ix /= 0) isotope_=isotopes(ix); END IF
+  IF(PRESENT(isotope_ )) THEN; ix = strIdx(isotopes(:)%parent, isotope%parent); IF(ix /= 0) isotope_=isotopes(ix); END IF
 END SUBROUTINE getKeysDBase
 !==============================================================================================================================
@@ -2583,10 +2605,10 @@
   CHARACTER(LEN=*),             INTENT(IN)    :: tname
   TYPE(keys_type),              INTENT(IN)    ::  keys
-  TYPE(keys_type), ALLOCATABLE, INTENT(INOUT) :: tracs(:)
-  TYPE(keys_type), ALLOCATABLE :: tr(:)
+  TYPE(trac_type), ALLOCATABLE, INTENT(INOUT) :: tracs(:)
+  TYPE(trac_type), ALLOCATABLE :: tr(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
   INTEGER :: nt, ix
   IF(ALLOCATED(tracs)) THEN
-     lerr = getKey('name', tnames, ky=tracs(:)); IF(lerr) RETURN
+     lerr = getKey('name', tnames, ky=tracs(:)%keys); IF(lerr) RETURN
      nt = SIZE(tracs)
      ix = strIdx(tnames, tname)
@@ -2600,6 +2622,7 @@
      ix = 1; ALLOCATE(tracs(1))
   END IF
-  CALL addKey('name', tname, tracs(ix))
-  tracs(ix) = keys
+  CALL addKey('name', tname, tracs(ix)%keys)
+  tracs(ix)%name = tname
+  tracs(ix)%keys = keys
 
 END FUNCTION addTracer_1
@@ -2616,6 +2639,6 @@
 LOGICAL FUNCTION delTracer_1(tname, tracs) RESULT(lerr)
   CHARACTER(LEN=*),                     INTENT(IN)    :: tname
-  TYPE(keys_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: tracs(:)
-  TYPE(keys_type), ALLOCATABLE :: tr(:)
+  TYPE(trac_type), ALLOCATABLE, TARGET, INTENT(INOUT) :: tracs(:)
+  TYPE(trac_type), ALLOCATABLE :: tr(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE :: tnames(:)
   INTEGER :: nt, ix
@@ -2623,5 +2646,5 @@
   IF(fmsg('Can''t remove tracer "'//TRIM(tname)//'" from an empty tracers descriptor', modname, lerr)) RETURN
   nt = SIZE(tracs)
-  lerr = getKey('name', tnames, ky=tracs(:)); IF(lerr) RETURN
+  lerr = getKey('name', tnames, ky=tracs(:)%keys); IF(lerr) RETURN
   ix = strIdx(tnames, tname)
   CALL msg('Removing tracer "'             //TRIM(tname)//'"', modname, ix /= 0)
@@ -2667,7 +2690,6 @@
 
 !==============================================================================================================================
-!======== CONVERT WATER-DERIVED NAMES FROM FORMER TO CURRENT CONVENTION & VICE VERSA ; OTHER NAMES ARE LEFT UNTOUCHED =========
-!===== OLD NAMES STRUCTURE:  H2O[<phase>][_<isotope>][_<tag>] (<phase> from "old_phases",        <isotope> from "oldH2OIso") ==
-!====  NEW NAMES STRUCTURE: <var>[<phase_sep><phase>][_<tag>] (<phase> from "known_phases", <var>='H2O' or from "newH2OIso") ==
+!============ CONVERT WATER-DERIVED NAMES FROM FORMER TO CURRENT CONVENTION ; OTHER NAMES ARE LEFT UNTOUCHED ==================
+!======= NAMES STRUCTURE: H2O[<phase>][_<isotope>][_<tag>] (<phase> from "old_phases", <isotope> from "oldH2OIso") ============
 !==============================================================================================================================
 CHARACTER(LEN=maxlen) FUNCTION old2newH2O_1(oldName, iPhase) RESULT(newName)
@@ -2702,4 +2724,10 @@
 END FUNCTION old2newH2O_m
 !==============================================================================================================================
+
+
+!==============================================================================================================================
+!============ CONVERT WATER-DERIVED NAMES FROM CURRENT TO FORMER CONVENTION ; OTHER NAMES ARE LEFT UNTOUCHED ==================
+!==== NAMES STRUCTURE: <var>[<phase_sep><phase>][_<tag>] (<phase> from "known_phases", <var> = 'H2O' or from "newH2OIso") =====
+!==============================================================================================================================
 CHARACTER(LEN=maxlen) FUNCTION new2oldH2O_1(newName, iPhase) RESULT(oldName)
   CHARACTER(LEN=*),  INTENT(IN)  :: newName
